"{ Package: 'stx:goodies/petitparser/compiler' }"

PPCNode subclass:#PPCAbstractPredicateNode
	instanceVariableNames:'predicate'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCAbstractPredicateNode class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!PPCAbstractPredicateNode methodsFor:'accessing'!

predicate
	
	^ predicate
!

predicate: anObject
	
	predicate := anObject
!

prefix
	^ #predicate
! !

!PPCAbstractPredicateNode methodsFor:'analysis'!

acceptsEpsilon
	^ false
!

firstCharParser
	^ PPPredicateObjectParser on: predicate message: 'predicate expected'.
!

firstCharSet
	^ PPCharSetPredicate on: predicate
! !

!PPCAbstractPredicateNode methodsFor:'comparison'!

= anotherNode
	super = anotherNode ifFalse: [ ^ false ].
	^ predicate = anotherNode predicate.
!

hash
	^ super hash bitXor: predicate hash
! !

!PPCAbstractPredicateNode methodsFor:'compiling'!

bodyOfPredicate: compiler
	self subclassResponsibility
!

compileWith: compiler effect: effect id: id
	compiler startMethod: id.
	compiler add: '^'.
	self bodyOfPredicate: compiler.
 ^ compiler stopMethod.
!

extendClassification: classification
	^ (classification asOrderedCollection addLast: false; yourself) asArray
! !

!PPCAbstractPredicateNode methodsFor:'initialization'!

initialize
	super initialize.
! !

!PPCAbstractPredicateNode methodsFor:'optimizing'!

asInlined
	^ super asInlined
!

optimize: params status: changeStatus
	| retval |
	retval := self.
	retval := retval rewrite: params status: changeStatus.
	retval := retval inline: params status: changeStatus.
	
	^ retval
! !

