"{ Package: 'stx:goodies/petitparser/compiler' }"

PPCStarNode subclass:#PPCStarMessagePredicateNode
	instanceVariableNames:'message'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Nodes'
!

!PPCStarMessagePredicateNode methodsFor:'accessing'!

acceptsEpsilon
	^ true
!

firstCharSet
	^ PPCharSetPredicate on: [:char | char perform: message ] 	
!

message
	
	^ message
!

message: anObject
	
	message := anObject
!

prefix
	^ #starPredicate
!

rewrite: changeStatus
	"Nothing TODO"
! !

!PPCStarMessagePredicateNode methodsFor:'as yet unclassified'!

compileWith: compiler effect: effect id: id
	compiler startMethod: id.
	compiler addVariable: 'retval'.
	compiler add: 'retval := OrderedCollection new.'.	
	compiler add: '[ context peek ', message, ' ] whileTrue: ['.
	compiler indent.
	compiler add: ' retval add: context next'.
	compiler dedent.
	compiler add: '].'.
	compiler add: '^ retval asArray'.
 ^ compiler stopMethod.
!

compileWith_old: compiler effect: effect id: id
	compiler startMethod: id.
	compiler addVariable: 'retval'.
	compiler add: 'retval := OrderedCollection new.'.	
	compiler add: '[ context atEnd ] whileFalse: ['.
	compiler indent.
	compiler add: '(context uncheckedPeek ', message,')'.
	compiler indent.
	compiler add: ' ifFalse: [ ^ retval asArray ].'.
	compiler dedent.
	compiler add: ' retval add: context next'.
	compiler dedent.
	compiler add: '].'.
	compiler add: '^ retval asArray'.
 ^ compiler stopMethod.
! !

!PPCStarMessagePredicateNode methodsFor:'comparing'!

= anotherNode
	super = anotherNode ifFalse: [ ^ false ].
	^ message = anotherNode message.
!

hash
	^ super hash bitXor: message hash
! !

!PPCStarMessagePredicateNode methodsFor:'optimizing'!

asFast
	^ PPCTokenStarMessagePredicateNode new
		name: name;
		message: message;
		child: child;
		yourself
! !

